searchNodes=[{"doc":"Functions within this module provide the public interface for Historian. If it&#39;s your first time using Historian please use Historian.view_history/0 or Historian.tui!/0 to setup the persistent archive.","ref":"Historian.html","title":"Historian","type":"module"},{"doc":"Create an archive entry with the given name and value. Parameters entry_name: Name of the new entry entry_value: Value (i.e. content) of the new entry","ref":"Historian.html#archive_entry!/2","title":"Historian.archive_entry!/2","type":"function"},{"doc":"Create an archive entry with the given name using the contents of your clipboard. Parameters entry_name: Name of the entry to eval.","ref":"Historian.html#archive_from_clipboard!/1","title":"Historian.archive_from_clipboard!/1","type":"function"},{"doc":"Create an archive entry from the current history buffer, extracting it with given action and action opts. Parameters entry_name: Name of the entry to eval. action: Action to use for extracting the value from the history buffer, either slice/3 or pluck/2. action_opts: List of arguments for the given action, see an action&#39;s documentation for required args.","ref":"Historian.html#archive_from_history!/3","title":"Historian.archive_from_history!/3","type":"function"},{"doc":"Copy the entry&#39;s contents to your clipboard, returns {:ok, data} if was copied to your clipboard successfully or {:error, reason} if there was a problem. Parameters entry_name: Name of the entry to copy. Usage over SSH If you want to use Historian on a remote system, you&#39;ll need to properly configure SSH or coping lines will fail. Eventually, there will be a guide on how to use Historian with SSH.","ref":"Historian.html#copy/1","title":"Historian.copy/1","type":"function"},{"doc":"","ref":"Historian.html#current_history/0","title":"Historian.current_history/0","type":"function"},{"doc":"Turn the entry into a zero-arity function; uses Code.eval_string/1 to call the given lines within the function. Parameters entry_name: Name of the entry to turn into a function.","ref":"Historian.html#entry_to_fun/1","title":"Historian.entry_to_fun/1","type":"function"},{"doc":"Evaluate the entry and return the result; uses Code.eval_string/1 to obtain the result. Parameters entry_name: Name of the entry to eval.","ref":"Historian.html#eval_entry/1","title":"Historian.eval_entry/1","type":"function"},{"doc":"","ref":"Historian.html#line/1","title":"Historian.line/1","type":"function"},{"doc":"","ref":"Historian.html#next_page/1","title":"Historian.next_page/1","type":"function"},{"doc":"","ref":"Historian.html#page/2","title":"Historian.page/2","type":"function"},{"doc":"Print the page and update the process&#39;s current page to be the provided page number.","ref":"Historian.html#page!/2","title":"Historian.page!/2","type":"function"},{"doc":"","ref":"Historian.html#pages/1","title":"Historian.pages/1","type":"function"},{"doc":"","ref":"Historian.html#pluck/1","title":"Historian.pluck/1","type":"function"},{"doc":"","ref":"Historian.html#prev_page/1","title":"Historian.prev_page/1","type":"function"},{"doc":"","ref":"Historian.html#print_archive/0","title":"Historian.print_archive/0","type":"function"},{"doc":"","ref":"Historian.html#print_pluck/1","title":"Historian.print_pluck/1","type":"function"},{"doc":"Search the current history buffer for lines matching the term and print them to screen.","ref":"Historian.html#search/1","title":"Historian.search/1","type":"function"},{"doc":"Search the current history buffer for lines matching the term and print them to screen.","ref":"Historian.html#search/2","title":"Historian.search/2","type":"function"},{"doc":"Select the given lines (from the last history buffer) and print them to screen. Parameters start: Line number to start selecting lines at stop: Line number to stop selecting lines at","ref":"Historian.html#select/2","title":"Historian.select/2","type":"function"},{"doc":"","ref":"Historian.html#select/3","title":"Historian.select/3","type":"function"},{"doc":"","ref":"Historian.html#tui!/1","title":"Historian.tui!/1","type":"function"},{"doc":"Print the contents of the matching archive entry or a message saying there is no matching entry. Parameters entry_name: Name of the entry to view. opts: pretty_print: false is the default, setting to true will output using Code.format_string!/1","ref":"Historian.html#view_entry/2","title":"Historian.view_entry/2","type":"function"},{"doc":"Starts an interactive Historian session. Parameters lines: Number of lines of history to load into the buffer Historian UI. start: Offset for number of lines.","ref":"Historian.html#view_history/2","title":"Historian.view_history/2","type":"function"},{"doc":"An alias of tui!/0.","ref":"Historian.html#view_page/0","title":"Historian.view_page/0","type":"function"},{"doc":"Starts an interactive Historian session using the provided page buffer process. If no page number is provided the current page from the given page buffer process will be used. Parameters pager: The pid for a Historian.PageBuffer process. page: The page to show in the Terminal UI","ref":"Historian.html#view_page/2","title":"Historian.view_page/2","type":"function"},{"doc":"A process responsible for managing the user&#39;s archive. Details The archive&#39;s database is an ets table, the persistence feature uses :ets.tab2file/2 to write the table to disk, enabling the archive&#39;s visibility across applications.","ref":"Historian.Archive.html","title":"Historian.Archive","type":"module"},{"doc":"","ref":"Historian.Archive.html#all/1","title":"Historian.Archive.all/1","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Historian.Archive.html#child_spec/1","title":"Historian.Archive.child_spec/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#configured?/1","title":"Historian.Archive.configured?/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#db_table/1","title":"Historian.Archive.db_table/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#delete_value/2","title":"Historian.Archive.delete_value/2","type":"function"},{"doc":"","ref":"Historian.Archive.html#dump/1","title":"Historian.Archive.dump/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Historian.Archive.html#init/1","title":"Historian.Archive.init/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#insert_value/3","title":"Historian.Archive.insert_value/3","type":"function"},{"doc":"","ref":"Historian.Archive.html#read_value/2","title":"Historian.Archive.read_value/2","type":"function"},{"doc":"","ref":"Historian.Archive.html#save!/1","title":"Historian.Archive.save!/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#setup!/1","title":"Historian.Archive.setup!/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#start_link/1","title":"Historian.Archive.start_link/1","type":"function"},{"doc":"","ref":"Historian.Archive.html#update_value/3","title":"Historian.Archive.update_value/3","type":"function"},{"doc":"","ref":"Historian.Archive.Item.html","title":"Historian.Archive.Item","type":"module"},{"doc":"","ref":"Historian.Archive.Item.html#new/2","title":"Historian.Archive.Item.new/2","type":"function"},{"doc":"Ring buffer for holding managing the current history. Historian uses a ring buffer to store in-session history slices, providing the user a way to access previous slices in case they accidentally shit on their history between calls to slice.","ref":"Historian.Buffer.html","title":"Historian.Buffer","type":"module"},{"doc":"","ref":"Historian.Buffer.html#first/0","title":"Historian.Buffer.first/0","type":"function"},{"doc":"","ref":"Historian.Buffer.html#get/1","title":"Historian.Buffer.get/1","type":"function"},{"doc":"","ref":"Historian.Buffer.html#handle_call/3","title":"Historian.Buffer.handle_call/3","type":"function"},{"doc":"","ref":"Historian.Buffer.html#init/1","title":"Historian.Buffer.init/1","type":"function"},{"doc":"","ref":"Historian.Buffer.html#list/0","title":"Historian.Buffer.list/0","type":"function"},{"doc":"","ref":"Historian.Buffer.html#push/1","title":"Historian.Buffer.push/1","type":"function"},{"doc":"","ref":"Historian.Buffer.html#start_link/1","title":"Historian.Buffer.start_link/1","type":"function"},{"doc":"Functionality related to copy and pasting using the operating system&#39;s clipboard.","ref":"Historian.Clipboard.html","title":"Historian.Clipboard","type":"module"},{"doc":"","ref":"Historian.Clipboard.html#copy/1","title":"Historian.Clipboard.copy/1","type":"function"},{"doc":"","ref":"Historian.Clipboard.html#paste/0","title":"Historian.Clipboard.paste/0","type":"function"},{"doc":"","ref":"Historian.Clipboard.html#t:copy_result/0","title":"Historian.Clipboard.copy_result/0","type":"type"},{"doc":"","ref":"Historian.Clipboard.html#t:missing_x_server/0","title":"Historian.Clipboard.missing_x_server/0","type":"type"},{"doc":"","ref":"Historian.Clipboard.html#t:success/0","title":"Historian.Clipboard.success/0","type":"type"},{"doc":"","ref":"Historian.Clipboard.html#t:unknown_os_error/0","title":"Historian.Clipboard.unknown_os_error/0","type":"type"},{"doc":"","ref":"Historian.Config.html","title":"Historian.Config","type":"module"},{"doc":"","ref":"Historian.Config.html#archive_filename/0","title":"Historian.Config.archive_filename/0","type":"function"},{"doc":"","ref":"Historian.Config.html#archive_path/0","title":"Historian.Config.archive_path/0","type":"function"},{"doc":"","ref":"Historian.Config.html#archive_table_name/0","title":"Historian.Config.archive_table_name/0","type":"function"},{"doc":"","ref":"Historian.Config.html#color/2","title":"Historian.Config.color/2","type":"function"},{"doc":"","ref":"Historian.Config.html#config_path/0","title":"Historian.Config.config_path/0","type":"function"},{"doc":"","ref":"Historian.Config.html#persist_archive?/0","title":"Historian.Config.persist_archive?/0","type":"function"},{"doc":"","ref":"Historian.Gettext.html","title":"Historian.Gettext","type":"module"},{"doc":"Callback implementation for Gettext.Backend.dgettext/3.","ref":"Historian.Gettext.html#dgettext/3","title":"Historian.Gettext.dgettext/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dgettext_noop/2.","ref":"Historian.Gettext.html#dgettext_noop/2","title":"Historian.Gettext.dgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext/5.","ref":"Historian.Gettext.html#dngettext/5","title":"Historian.Gettext.dngettext/5","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dngettext_noop/3.","ref":"Historian.Gettext.html#dngettext_noop/3","title":"Historian.Gettext.dngettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpgettext/4.","ref":"Historian.Gettext.html#dpgettext/4","title":"Historian.Gettext.dpgettext/4","type":"macro"},{"doc":"","ref":"Historian.Gettext.html#dpgettext_noop/3","title":"Historian.Gettext.dpgettext_noop/3","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.dpngettext/6.","ref":"Historian.Gettext.html#dpngettext/6","title":"Historian.Gettext.dpngettext/6","type":"macro"},{"doc":"","ref":"Historian.Gettext.html#dpngettext_noop/4","title":"Historian.Gettext.dpngettext_noop/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext/2.","ref":"Historian.Gettext.html#gettext/2","title":"Historian.Gettext.gettext/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_comment/1.","ref":"Historian.Gettext.html#gettext_comment/1","title":"Historian.Gettext.gettext_comment/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.gettext_noop/1.","ref":"Historian.Gettext.html#gettext_noop/1","title":"Historian.Gettext.gettext_noop/1","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_bindings/2.","ref":"Historian.Gettext.html#handle_missing_bindings/2","title":"Historian.Gettext.handle_missing_bindings/2","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_plural_translation/6.","ref":"Historian.Gettext.html#handle_missing_plural_translation/6","title":"Historian.Gettext.handle_missing_plural_translation/6","type":"function"},{"doc":"Callback implementation for Gettext.Backend.handle_missing_translation/4.","ref":"Historian.Gettext.html#handle_missing_translation/4","title":"Historian.Gettext.handle_missing_translation/4","type":"function"},{"doc":"","ref":"Historian.Gettext.html#lgettext/5","title":"Historian.Gettext.lgettext/5","type":"function"},{"doc":"","ref":"Historian.Gettext.html#lngettext/7","title":"Historian.Gettext.lngettext/7","type":"function"},{"doc":"Callback implementation for Gettext.Backend.ngettext/4.","ref":"Historian.Gettext.html#ngettext/4","title":"Historian.Gettext.ngettext/4","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.ngettext_noop/2.","ref":"Historian.Gettext.html#ngettext_noop/2","title":"Historian.Gettext.ngettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pgettext/3.","ref":"Historian.Gettext.html#pgettext/3","title":"Historian.Gettext.pgettext/3","type":"macro"},{"doc":"","ref":"Historian.Gettext.html#pgettext_noop/2","title":"Historian.Gettext.pgettext_noop/2","type":"macro"},{"doc":"Callback implementation for Gettext.Backend.pngettext/5.","ref":"Historian.Gettext.html#pngettext/5","title":"Historian.Gettext.pngettext/5","type":"macro"},{"doc":"","ref":"Historian.Gettext.html#pngettext_noop/3","title":"Historian.Gettext.pngettext_noop/3","type":"macro"},{"doc":"A data structure for managing histories.","ref":"Historian.History.html","title":"Historian.History","type":"module"},{"doc":"","ref":"Historian.History.html#create/2","title":"Historian.History.create/2","type":"function"},{"doc":"Returns a line from the history buffer by it&#39;s index.","ref":"Historian.History.html#line_at/2","title":"Historian.History.line_at/2","type":"function"},{"doc":"Pluck takes a list of line ids returning an updated history buffer containing only lines coresponding to the ids.","ref":"Historian.History.html#pluck/2","title":"Historian.History.pluck/2","type":"function"},{"doc":"Pluck takes a list of line numbers returning a list containing only lines coresponding to the matching ids (or an empty list if there are no matches).","ref":"Historian.History.html#pluck!/2","title":"Historian.History.pluck!/2","type":"function"},{"doc":"Search the history buffer&#39;s values matching the pattern, and return an updated History buffer containing only the matching items.","ref":"Historian.History.html#search/2","title":"Historian.History.search/2","type":"function"},{"doc":"Search the history buffer&#39;s values matching the pattern, and return only the matching items.","ref":"Historian.History.html#search!/2","title":"Historian.History.search!/2","type":"function"},{"doc":"Slice the history buffer&#39;s using the given bounds, and return a list containing only the sliced items.","ref":"Historian.History.html#slice/3","title":"Historian.History.slice/3","type":"function"},{"doc":"Slice the history buffer&#39;s using the given bounds, and return an updated buffer containing only the sliced items.","ref":"Historian.History.html#slice!/3","title":"Historian.History.slice!/3","type":"function"},{"doc":"","ref":"Historian.History.html#t:t/1","title":"Historian.History.t/1","type":"type"},{"doc":"A data structure and functions for history items.","ref":"Historian.History.Item.html","title":"Historian.History.Item","type":"module"},{"doc":"","ref":"Historian.History.Item.html#t:t/0","title":"Historian.History.Item.t/0","type":"type"},{"doc":"A buffer to manage paging your history... by &quot;snapshotting&quot; when the buffer was created.","ref":"Historian.PageBuffer.html","title":"Historian.PageBuffer","type":"module"},{"doc":"","ref":"Historian.PageBuffer.html#current/1","title":"Historian.PageBuffer.current/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#first/1","title":"Historian.PageBuffer.first/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#get/2","title":"Historian.PageBuffer.get/2","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#get_line/2","title":"Historian.PageBuffer.get_line/2","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#handle_call/3","title":"Historian.PageBuffer.handle_call/3","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#handle_continue/2","title":"Historian.PageBuffer.handle_continue/2","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#info/1","title":"Historian.PageBuffer.info/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#init/1","title":"Historian.PageBuffer.init/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#last/1","title":"Historian.PageBuffer.last/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#next/1","title":"Historian.PageBuffer.next/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#prev/1","title":"Historian.PageBuffer.prev/1","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#set_page/2","title":"Historian.PageBuffer.set_page/2","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#start_link/2","title":"Historian.PageBuffer.start_link/2","type":"function"},{"doc":"","ref":"Historian.PageBuffer.html#t:page_result/0","title":"Historian.PageBuffer.page_result/0","type":"type"},{"doc":"","ref":"Historian.PageBuffer.html#t:t/0","title":"Historian.PageBuffer.t/0","type":"type"},{"doc":"","ref":"Historian.TUi.ArchiveView.html","title":"Historian.TUi.ArchiveView","type":"module"},{"doc":"","ref":"Historian.TUi.ArchiveView.html#render/1","title":"Historian.TUi.ArchiveView.render/1","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html","title":"Historian.TUi.Elements","type":"module"},{"doc":"","ref":"Historian.TUi.Elements.html#column_panel/7","title":"Historian.TUi.Elements.column_panel/7","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#history_item/4","title":"Historian.TUi.Elements.history_item/4","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#history_item/5","title":"Historian.TUi.Elements.history_item/5","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#history_split_view/6","title":"Historian.TUi.Elements.history_split_view/6","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#menu_bar/2","title":"Historian.TUi.Elements.menu_bar/2","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#navigation_item/3","title":"Historian.TUi.Elements.navigation_item/3","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#navigation_option/4","title":"Historian.TUi.Elements.navigation_option/4","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#navigation_option/5","title":"Historian.TUi.Elements.navigation_option/5","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#screen_navigation/5","title":"Historian.TUi.Elements.screen_navigation/5","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#status_bar/4","title":"Historian.TUi.Elements.status_bar/4","type":"function"},{"doc":"","ref":"Historian.TUi.Elements.html#viewport_offset/2","title":"Historian.TUi.Elements.viewport_offset/2","type":"function"},{"doc":"","ref":"Historian.TUi.HistoryView.html","title":"Historian.TUi.HistoryView","type":"module"},{"doc":"","ref":"Historian.TUi.HistoryView.html#history_status_bar/2","title":"Historian.TUi.HistoryView.history_status_bar/2","type":"function"},{"doc":"","ref":"Historian.TUi.HistoryView.html#render/1","title":"Historian.TUi.HistoryView.render/1","type":"function"},{"doc":"Creates modal or overlay views (primarily used by the archiving system)","ref":"Historian.TUi.ModalView.html","title":"Historian.TUi.ModalView","type":"module"},{"doc":"","ref":"Historian.TUi.ModalView.html#dialog_box/7","title":"Historian.TUi.ModalView.dialog_box/7","type":"function"},{"doc":"","ref":"Historian.TUi.ModalView.html#edit_dialog_box/5","title":"Historian.TUi.ModalView.edit_dialog_box/5","type":"function"},{"doc":"","ref":"Historian.TUi.ModalView.html#focusable_element/3","title":"Historian.TUi.ModalView.focusable_element/3","type":"function"},{"doc":"","ref":"Historian.TUi.ModalView.html#focusable_element/4","title":"Historian.TUi.ModalView.focusable_element/4","type":"function"},{"doc":"","ref":"Historian.TUi.ModalView.html#highlight_element/3","title":"Historian.TUi.ModalView.highlight_element/3","type":"function"},{"doc":"","ref":"Historian.TUi.ModalView.html#new_dialog_box/5","title":"Historian.TUi.ModalView.new_dialog_box/5","type":"function"},{"doc":"","ref":"Historian.TUi.Search.html","title":"Historian.TUi.Search","type":"module"},{"doc":"","ref":"Historian.TUi.Search.html#render/1","title":"Historian.TUi.Search.render/1","type":"function"},{"doc":"","ref":"Historian.TUi.Search.html#search_bar/1","title":"Historian.TUi.Search.search_bar/1","type":"function"},{"doc":"","ref":"Historian.TUi.Search.html#search_item/4","title":"Historian.TUi.Search.search_item/4","type":"function"},{"doc":"","ref":"Historian.TUi.Search.html#search_status_bar/3","title":"Historian.TUi.Search.search_status_bar/3","type":"function"},{"doc":"","ref":"Historian.TUi.Search.html#search_status_bar/5","title":"Historian.TUi.Search.search_status_bar/5","type":"function"},{"doc":"Welcome Screen UI shown when running Historian for first time.","ref":"Historian.TUi.Welcome.html","title":"Historian.TUi.Welcome","type":"module"},{"doc":"","ref":"Historian.TUi.Welcome.html#automatic_setup_text/0","title":"Historian.TUi.Welcome.automatic_setup_text/0","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#exit_setup_text/0","title":"Historian.TUi.Welcome.exit_setup_text/0","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#logo_text/0","title":"Historian.TUi.Welcome.logo_text/0","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#manual_setup_text/0","title":"Historian.TUi.Welcome.manual_setup_text/0","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#render/1","title":"Historian.TUi.Welcome.render/1","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#welcome_status_bar/1","title":"Historian.TUi.Welcome.welcome_status_bar/1","type":"function"},{"doc":"","ref":"Historian.TUi.Welcome.html#welcome_text/0","title":"Historian.TUi.Welcome.welcome_text/0","type":"function"},{"doc":"","ref":"Historian.TerminalUI.html","title":"Historian.TerminalUI","type":"module"},{"doc":"Callback implementation for Ratatouille.App.init/1.","ref":"Historian.TerminalUI.html#init/1","title":"Historian.TerminalUI.init/1","type":"function"},{"doc":"Callback implementation for Ratatouille.App.render/1.","ref":"Historian.TerminalUI.html#render/1","title":"Historian.TerminalUI.render/1","type":"function"},{"doc":"Callback implementation for Ratatouille.App.update/2.","ref":"Historian.TerminalUI.html#update/2","title":"Historian.TerminalUI.update/2","type":"function"},{"doc":"","ref":"Historian.TerminalUI.ArchiveItemFormViewModel.html","title":"Historian.TerminalUI.ArchiveItemFormViewModel","type":"module"},{"doc":"","ref":"Historian.TerminalUI.ArchiveItemFormViewModel.html#new/1","title":"Historian.TerminalUI.ArchiveItemFormViewModel.new/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.ArchiveViewModel.html","title":"Historian.TerminalUI.ArchiveViewModel","type":"module"},{"doc":"","ref":"Historian.TerminalUI.ArchiveViewModel.html#new/1","title":"Historian.TerminalUI.ArchiveViewModel.new/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html","title":"Historian.TerminalUI.Cursor","type":"module"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#down/1","title":"Historian.TerminalUI.Cursor.down/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#down!/1","title":"Historian.TerminalUI.Cursor.down!/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#new/2","title":"Historian.TerminalUI.Cursor.new/2","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#position/1","title":"Historian.TerminalUI.Cursor.position/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#selected?/2","title":"Historian.TerminalUI.Cursor.selected?/2","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#up/1","title":"Historian.TerminalUI.Cursor.up/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#up!/1","title":"Historian.TerminalUI.Cursor.up!/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.Cursor.html#value_at/2","title":"Historian.TerminalUI.Cursor.value_at/2","type":"function"},{"doc":"","ref":"Historian.TerminalUI.HistoryViewModel.html","title":"Historian.TerminalUI.HistoryViewModel","type":"module"},{"doc":"","ref":"Historian.TerminalUI.HistoryViewModel.html#new/1","title":"Historian.TerminalUI.HistoryViewModel.new/1","type":"function"},{"doc":"","ref":"Historian.TerminalUI.SearchViewModel.html","title":"Historian.TerminalUI.SearchViewModel","type":"module"},{"doc":"","ref":"Historian.TerminalUI.SearchViewModel.html#new/2","title":"Historian.TerminalUI.SearchViewModel.new/2","type":"function"},{"doc":"Functions for outputting text directly to the terminal, i.e. the opposite of the TUI.","ref":"Historian.TextUI.html","title":"Historian.TextUI","type":"module"},{"doc":"","ref":"Historian.TextUI.html#archive_item/3","title":"Historian.TextUI.archive_item/3","type":"function"},{"doc":"","ref":"Historian.TextUI.html#archive_item/4","title":"Historian.TextUI.archive_item/4","type":"function"},{"doc":"","ref":"Historian.TextUI.html#history_item/3","title":"Historian.TextUI.history_item/3","type":"function"},{"doc":"","ref":"Historian.TextUI.html#lines/3","title":"Historian.TextUI.lines/3","type":"function"},{"doc":"","ref":"Historian.TextUI.html#page/3","title":"Historian.TextUI.page/3","type":"function"},{"doc":"","ref":"Historian.TextUI.html#search_results/2","title":"Historian.TextUI.search_results/2","type":"function"},{"doc":"","ref":"Historian.TextUI.html#table/1","title":"Historian.TextUI.table/1","type":"function"},{"doc":"Stores the PageBuffer process for the TUI","ref":"Historian.UserInterfaceServer.html","title":"Historian.UserInterfaceServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Historian.UserInterfaceServer.html#child_spec/1","title":"Historian.UserInterfaceServer.child_spec/1","type":"function"},{"doc":"Get the current page buffer in the Historian.UserInterfaceServer process. Returns: {:ok, page_buffer_pid} - Success result. {:error, :dead_pid} - Page buffer process is nothing but a dreadful reminder of our endless march towards death and being forgotten. {:error, :stale_pid} - Reference belongs to a stale pid, if you do not care about the old pid, you can call this function with nil and it will return whatever the current pid is bypassing the reference check. Parameters page_ref: The reference returned when setting the page buffer or nil to skip stale ref check.","ref":"Historian.UserInterfaceServer.html#get/1","title":"Historian.UserInterfaceServer.get/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Historian.UserInterfaceServer.html#init/1","title":"Historian.UserInterfaceServer.init/1","type":"function"},{"doc":"Sets the page buffer in the Historian.UserInterfaceServer process, returns {:ok, ref} if the process has been successfully set or {:error, :dead_pid} if the process&#39;s spark of life has been smothered in shite... Parameters pager: The pid for a Historian.PageBuffer process.","ref":"Historian.UserInterfaceServer.html#set/1","title":"Historian.UserInterfaceServer.set/1","type":"function"},{"doc":"","ref":"Historian.UserInterfaceServer.html#start_link/1","title":"Historian.UserInterfaceServer.start_link/1","type":"function"},{"doc":"Historian ██╗ ██╗██╗███████╗████████╗ ██████╗ ██████╗ ██╗ █████╗ ███╗ ██╗ ██║ ██║██║██╔════╝╚══██╔══╝██╔═══██╗██╔══██╗██║██╔══██╗████╗ ██║ ███████║██║███████╗ ██║ ██║ ██║██████╔╝██║███████║██╔██╗ ██║ ██╔══██║██║╚════██║ ██║ ██║ ██║██╔══██╗██║██╔══██║██║╚██╗██║ ██║ ██║██║███████║ ██║ ╚██████╔╝██║ ██║██║██║ ██║██║ ╚████║ ╚═╝ ╚═╝╚═╝╚══════╝ ╚═╝ ╚═════╝ ╚═╝ ╚═╝╚═╝╚═╝ ╚═╝╚═╝ ╚═══╝ [beta] An interactive history manager and snippet archival tool for IEx. Historian is a developer tool to make interacting with your IEx history easier by providing text and/or graphical (TUI) utilities to search, page through, copy and paste, and even save specific line(s) or snippets to a persistent archive [db]. Historian comes with two modes an inline &quot;text mode&quot; which you can interact with by calling Historian directly, or a &quot;Terminal User Interface&quot; (TUI) which provides a graphical interface for using Historian. Please see the features section for a walkthrough of each. It&#39;s completely non-destructive to your history so give it a try, in fact, all it really does is make :group_history more pleasant to work with. [db]: It&#39;s an ETS table persisted to disk, please see installation and setup for more details.","ref":"readme.html","title":"Historian","type":"extras"},{"doc":"Historian is in beta, and may have bugs, or usability issues on some platforms or configurations. It is a developer tool, intended to only be used in :dev so the risk of any harm is low. MacOS, Linux, and Windows are all supported but Linux and Windows have had the least amount of testing as of February 16, 2020. I will update this once on those platforms (under various configurations) is verified correct. Bugs and Problems If you&#39;re feeling generous with your time, please create an issue with the details (including operating system, terminal application, and locale) and I will get it fixed up for you. Screenshots or gifs of issues are also tremendously helpful and appreciated. I am on Twitter and the Elixir slack under the same handle.","ref":"readme.html#status","title":"Historian - Status","type":"extras"},{"doc":"Features Installation &amp; Setup Configuration Roadmap Acknowledgements License","ref":"readme.html#table-of-contents","title":"Historian - Table of Contents","type":"extras"},{"doc":"View History Paging Filtering Archiving Creating an Entry Using an Entry Terminal UI History [1] Exiting Historian [ctrl+d] Navigating Lines [j] / [k] Searching [s] Viewing Your Archive [2] Editing An Archive Item [e] New Archive Item [n] View History View a specific line of history with line = 0 being the most recent line in your history: iex&gt; Historian.line(0) &quot;Historian.line(0)&quot; to view the last (oldest) line of your history you can set line = :infinity: iex&gt; Historian.line(:infinity) &quot;IO.puts(\\&quot;is this magic?\\&quot;)&quot; View the 100 most recent lines of your history: # We&#39;ll cover the pid in the section below iex&gt; _page_buffer_pid = Historian.pages() Paging Because the history is constantly changing, you can freeze it at a point in time, by reusing the Historian.PageBuffer pid that is returned from calling pages/1. Note: Page indexes start from 0 not 1. iex&gt; page_size = 10 # Creating a pager, takes an (in-memory) snapshot of your history, giving you an easier and more sane way to page # through it; since, each new line will no longer affect the offset. iex&gt; pager = Historian.pages(page_size) #&gt; Viewing page 0: #&gt; +---------------------------------------------------+ #&gt; | id | value | #&gt; +---------------------------------------------------+ #&gt; | 0 | Historian.pages(10) | #&gt; | 1 | Historian.view_history | #&gt; | 2 | Historian.Clipboard.paste() | #&gt; | 3 | Historian.view_history | #&gt; | 4 | Application.get_env(:historian, :colors) | #&gt; | 5 | Historian.view_history | #&gt; | 6 | Application.get_env(:historian, :colors) | #&gt; | 7 | Map.get(%{}, :shites) | #&gt; | 8 | Historian.view_history | #&gt; | 9 | r Historian.TUi.Elements | #&gt; +---------------------------------------------------+ # Display the first page (100 most recent lines) of history iex&gt; _pager = Historian.page(pager, 0) Historian.next_page/1 and Historian.prev_page/1 move the page buffer +1/-1 page at a time, each time updating the buffer&#39;s current page. iex&gt; page_size = 100 iex&gt; pager = Historian.pages(page_size) # Moves the buffer to the second page (index = 1) iex&gt; Historian.next_page(pager) # Moves the buffer back to the first page (index = 0) iex&gt; Historian.prev_page(pager) Historian.page/2 view a specific page in the buffer, without altering the current page: iex&gt; page_size = 100 iex&gt; pager = Historian.pages(page_size) # Assuming you have at least 28 pages of history (page numbers start from 0). iex&gt; _ = Historian.page(pager, 27) Historian.page!/2 view a specific page in the buffer AND update the current page in the buffer: iex&gt; page_size = 100 iex&gt; pager = Historian.pages(page_size) # Assuming you have at least 28 pages of history (page numbers start from 0). iex&gt; _ = Historian.page(pager, 27) Filtering Historian provides a few simple ways to filter and view your history. Historian.search/2 allow you can search through the current page of history, printing a table of the matching results with the search term highlighted. iex&gt; _ = Historian.search(pager, &quot;Historian.&quot;) Historian.search/1 will use an existing buffer (most recently created), or if there are no existing page buffers create a new one. iex&gt; _ = Historian.search(&quot;Historian.&quot;) Archive A unique feature of Historian is the &quot;archive of snipppets,&quot; i.e. the ability to save line(s), or your clipboard to an shortcut/alias/name. You can view your entire archive as a text formatted table with: iex&gt; Historian.print_archive() You can interact with Historian using the Historian module as outlined below or by using the TUI provided by calling Historian.view_history/2. Creating an Entry Creating an entry with a string: iex&gt; Historian.archive_entry!(:special_query, &quot;query = from(...)&quot;) &quot;query = from(...)&quot; from the clipboard contents: iex&gt; Historian.archive_from_clipboard!(:special_query) &quot;query = from(...)&quot; or from the history buffer: iex&gt; Historian.archive_from_history!(:wow_multiple_lines, :pluck, [1, 2, 33]) &quot;IO.inspect(:yolo)\\nIO.inspect(:womp)\\nIO.inspect(:nomp)&quot; Using an Entry You can then copy the entry to your clipboard with: iex&gt; Historian.copy(:special_query) {:ok, :copied_to_clipboard} eval it directly: iex&gt; Historian.eval_entry(:special_query) %Special.Result{magical: :yes} or even throw it into an anonymous function fn/0: iex&gt; my_fun = Historian.entry_to_fun(:special_query) iex&gt; my_fun.() %Special.Result{magical: :yes} You can also use Historian.Clipboard.paste/0 to get your clipboard as a two-item tuple: iex&gt; Historian.Clipboard.paste() {:ok, &quot;wow this is from my clipboard, cool, fresh...&quot;} Terminal UI In an iex session start the historian TUI with: iex&gt; Historian.tui!() Without providing any arguments, the UI defaults to showing the 100 most recent entries of your history. Passing in a PageBuffer process will open the UI to the buffer&#39;s current page. iex&gt; pager = Historian.pages(100) iex&gt; Historian.tui!(pager) As you read through the TUI features list, you&#39;ll notice next to the header for that entry there are braces containing a character(s); that&#39;s the key to press for that section. There may be more options within each sections details, but I&#39;ve put them there to make skimming this faster. History [1] You can pass in a specific page number to view by using Historian.view_page/2: iex&gt; pager = Historian.pages(100) iex&gt; page_ten = 10 # View page ten of the page buffer iex&gt; Historian.view_page(pager, page_ten) Historian.view_page/1 views the current page in the TUI: iex&gt; pager = Historian.pages(100) # Set the current page in the buffer to 111` iex&gt; _ = Historian.page(pager, 11) # Opens the UI to page 11 iex&gt; Historian.view_page(page) Exiting Historian [ctrl+d] To leave the historian interface and return to your iex prompt just press ctrl+d at anytime in the historian UI. Navigating Lines [j] / [k] You can view your history and scroll (j down/ k up) through entries, pressing y to copy the current line, spacebar to select multiple lines. Right now you cannot switch pages in the TUI, you gotta exit it first and change the page, this will be remedied in a future release. Searching [s] When viewing your history you can press s and Historian will filter entries on the page highlighting the matching portion, press enter to move up k and down j through entries and y to copy the selected line. Press e to refine your search. Viewing Your Archive [2] To view all archived materials using interactive mode, press 2 at anytime (except when searching, will be improved in a future release). You can navigate, select, and copy entries using the same j, k, and y commands as when viewing the history. note: To return to the history screen, press 1 There is an additional Y command which will join multiple lines in an entry using a space and a backslash, example output from using Y with these three lines selected: Something.create(%{coffee: :is_delicious}) |&gt; A.ReallyLong.And.Obtuse.Name.I.Would.Like.perform_magics() |&gt; IO.inspect(label: &quot;i am terrible at naming things&quot;) you would then have on your clipboard: Thinger.create(%{}) \\ |&gt; A.ReallyLong.And.Obtuse.Name.I.Would.Like.perform_something() \\ |&gt; IO.inspect(label: &quot;i am terrible at naming things&quot;) Editing an Archive Item [e] Select an archive item and press e to edit the name and content. Please note the TUI assumes all names are atoms AND anything you write in there will be turned into an atom[^1]. You can navigate the fields using the up ↑ and down ↓ arrows, once done, select either cancel or save and press enter. New Archive Item [n] Select an archive item and press n to create a new item. Please note the TUI assumes all names are atoms AND anything you write in there will be turned into an atom[^1]. You can navigate the fields using the up ↑ and down ↓ arrows, once done, select either cancel or save and press enter. [^1]: If this is actually a problem for anyone, file an issue, and I&#39;ll make it configurable.","ref":"readme.html#features","title":"Historian - Features","type":"extras"},{"doc":"Historian need to be added as a dependency or installed as an archive. Installation Project Dependency BELOW IS NOTHING BUT LIES IT HAS NOT BEEN PUBLISHED JUST YET, ADD DEP USING GIT OR CHECKOUT LOCALLY Historian is available in Hex, the package can be installed by adding historian to your list of dependencies in mix.exs: def deps do [ {:historian, &quot;~&gt; 0.11.1&quot;, only: :dev} ] end Manual Setup If you try to run this right now it&#39;ll probably complain about the path for the historian archive db. mkdir -p ~/.config/historian I&#39;ll get that ironed out (soon).","ref":"readme.html#installation-setup","title":"Historian - Installation &amp; Setup","type":"extras"},{"doc":"Below are all the configuration options (and their defaults) available in Historian: # This is the path historian will use to persist the Archive&#39;s ets table. config :historian, :config_path, Path.join([System.user_home(), &quot;.config&quot;, &quot;historian&quot;]) # This is the filename for the Historian ets table. config :historian, :archive_filename, &quot;historian-db.ets&quot; # The name of the archive&#39;s `ets` table, no reason to change this unless you # have a conflicting ets table (wow, what are the odds?). config :historian, :archive_table_name, :historian_archive_db # `nil` means unset and will be considered `true` at runtime, if you do not # want to persist the archive to disk you must set this to `false`. config :historian, :persist_archive, nil # A map of colors used by Historian. The primary purpose of this setting is for # accessibility, I don&#39;t want someone to have a shitty experience because I was # an asshole and chose colors that are hard for them to read. I will be adding # a few different color schemes (like purely black/white and a high contrast) # in a future release to make this a better experience. config :historian, :colors, %{ dialog_box_background: :white, dialog_box_cancel_text: :red, dialog_box_confirm_text: :cyan, dialog_box_content_panel_text: :black, dialog_box_label_background: :white, dialog_box_label_background_selected: :yellow, dialog_box_label_content_text: :yellow, dialog_box_selected_element: :yellow, dialog_box_text: :black, history_line_copied_line_ok: :yellow, history_line_multiselect_text_selected: :blue, history_split_view_panel_background_text: :black, history_split_view_panel_title_text: :cyan, screen_navigation_app_name_background: :cyan, screen_navigation_app_name_text: :black, screen_navigation_background: :black, screen_navigation_text: :white, screen_navigation_text_selected: :cyan, search_item_matching_text: :cyan, search_status_bar_background: :yellow, search_status_bar_text: :black }","ref":"readme.html#configuration","title":"Historian - Configuration","type":"extras"},{"doc":"[ ] Black and white mode [ ] High contrast mode [ ] Help screen in the TUI [ ] Setup CI setup with Github workflows [ ] Change page of the current buffer from the TUI [ ] Fix some terrible names of modules and functions (more so internally but public API could use some love) [ ] User configurable keyboard bindings [ ] More consistent UI making sure colors, text decorations, copy (verbiage), etc are consistent and coherent [ ] Search your archive [ ] Delete an item from your archive [ ] Improve editing an archive entry experience (even if it&#39;s marginally so, as I&#39;m not 100% not trying to pack a text editor in this bad-mama-jamma) [ ] Mix tasks for using Historian without entering IEx [ ] Mix tasks for: exporting, viewing, and backing up both your archive and history [ ] Localization, Gettext is in use almost everywhere (probably not used well, but it&#39;s my first rodeo with it) except the welcome screen; unfortunately though, I only know English... contributors wanted for localization! :) [ ] Make the Welcome TUI screen use Gettext","ref":"readme.html#roadmap-planned-features","title":"Historian - Roadmap &amp; Planned Features","type":"extras"},{"doc":"Terminal UI powered by ExTermbox and Ratatouille","ref":"readme.html#acknowledgements","title":"Historian - Acknowledgements","type":"extras"},{"doc":"Copyright 2020 Tehprofessor Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Historian - License","type":"extras"}]